﻿//	Spludlow Software
//	Copyright © Samuel P. Ludlow 2020 All Rights Reserved
//	Distributed under the terms of the GNU General Public License version 3
//	Distributed WITHOUT ANY WARRANTY; without implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE
//	https://www.spludlow.co.uk/LICENCE.TXT
//	The Spludlow logo is a registered trademark of Samuel P. Ludlow and may not be used without permission
//	v1.14

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

using System.Data;

[ServiceContract]
public interface IAdmin
{
	[OperationContract]
	void SetSecurityKey(string oldSecurityKey, string newSecurityKey);

	[OperationContract]
	int UpdateWebServiceAdmin(string securityKey);

	[OperationContract]
	string WebQuery(string securityKey, string applicationPoolName);

	[OperationContract]
	DataSet WebQueryAll(string securityKey);

	[OperationContract]
	DataSet WebQueries(string securityKey, string[] applicationPoolNames);


	[OperationContract]
	void WebRecycle(string securityKey, string applicationPoolName);

	[OperationContract]
	void WebRecycles(string securityKey, string[] applicationPoolNames);


	[OperationContract]
	void WebStart(string securityKey, string applicationPoolName);

	[OperationContract]
	void WebStarts(string securityKey, string[] applicationPoolNames);


	[OperationContract]
	void WebStop(string securityKey, string applicationPoolName);

	[OperationContract]
	void WebStops(string securityKey, string[] applicationPoolNames);


	[OperationContract]
	string ServiceQuery(string securityKey, string serviceName);

	[OperationContract]
	DataSet ServiceQueryAll(string securityKey);

	[OperationContract]
	DataSet ServiceQueries(string securityKey, string[] serviceNames);


	[OperationContract]
	void ServiceStart(string securityKey, string serviceName);

	[OperationContract]
	void ServiceStarts(string securityKey, string[] serviceNames);


	[OperationContract]
	void ServiceStop(string securityKey, string serviceName);

	[OperationContract]
	void ServiceStops(string securityKey, string[] serviceNames);


	[OperationContract]
	DataSet WebQuerySites(string securityKey);


	[OperationContract]
	string[] QueryEventLogs(string securityKey, int daysBack, bool includeEverything);


}
